package Termicos;
#Para circuitos termicos
#usados por simusol1.pl
use strict;
use Data::Dumper;
use Ayudas;
use GlobalesSimusol;
use Tablasfuncq;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
         &buscar_abreviaturas
         &cerofuentear
	 &interpretar_values_termico
	 &interpretar_values_iniciales
         &interpretar_var_termica
         &normalizar_abreviaturas
         &registrar_equivalencias
         &temperaturas 
         &tipear_cosa

     )
}
END();
# ---------------------------------------------------------------------------
sub cerofuentear{ 
   #agrega una fuente de corriente nula al circuito y devuelve
   #  VJ...." , pronto para referirse al voltaje de esa fuente   
    comfin('com cerofuentear',@_);
    my ($refcirc,$nodo,$otronodo) = (@_); my ($pre,$texto,$quien);
   if (not defined $otronodo) {
      $otronodo = '0';
      $pre = 'JN';
      $texto = $nodo;
   } else {
      $pre = 'JNN';
      $texto = "$nodo$otronodo";
   }; 
   if (length("$pre$texto") > 5
       or  defined $nombresusados{uc("$pre$texto")}) {
       $texto =1;
       $texto ++ while defined $nombresusados{uc("$pre$texto")} 
   };    
   $quien="$pre$texto";
   $nombresusados{uc($quien)} = 1;
   my $obj = $refcirc->{cualobjtextonodo}->{$nodo}->[0];
   push(@$laylista,$laylista->[$obj]); 
   push(@$plantillalista,$plantillalista->[$obj]);
   push(@$shapelista,$cualshape->{'flujod'}); #no importa si esta indefinido
   push(@$codlista,"J");
   push(@$textolista,"N$texto");
   push(@$codvalorlista,"J");
   push(@$lugarlista,$lugarlista->[$obj]);
   $refcirc->{uni}->{$quien} = "$nodo-$otronodo"; 
   cargar_datos($refcirc, 'DATOS', $quien, '0', 'n','',0
                         ,__LINE__.' Term cerofuentear');
   $refcirc->{cualobjele}->{$quien} = [scalar @$codlista - 1];
   push(@{$refcirc->{lisobjconectsnonodos}},scalar @$codlista - 1);
   if ($otronodo eq '0') {
       cargar_datos($refcirc, 'temp', $nodo,"V$quien",'a','',0
                         ,__LINE__.' Term cerofuentear'); 
       cargar_datos($refcirc, 'TEMP', $nodo,"V$quien",'a','',0
                         ,__LINE__.' Term cerofuentear'); 
   } else {
       cargar_datos($refcirc, 'temp', "$nodo-$otronodo","V$quien",'a','',0
                         ,__LINE__.' Term cerofuentear'); 
       cargar_datos($refcirc, 'TEMP', "$nodo-$otronodo","V$quien",'a','',0
                         ,__LINE__.' Term cerofuentear'); 
   };
   push @{$refcirc->{listaDATOS}}, "$quien"; # en cerofuentear
   $refcirc->{ELESPLANT}->{$quien} = $plantillalista->[$obj];
   comfin('fin cerofuentear',"V$quien");
   return "V$quien";
}; #cerofuentear

# ---------------------------------------------------------------------------
sub interpretar_var_termica{
  comfin('com interpretar_var_termica',@_);
  #interpreta las variables termicas de una expresion,
  #cambiandolas por las correspondientes electricas
  #$dado es la exprexion a interpretar
  #$refcirc debe admitir ->{cualobjele} y {cualobjtextonodo} y {temp}
  # TEMP de un elemento significa la diferencia de temperaturas 
  # entre sus bornes
  # FLUJO de un elemento significa la corriente a traves del elemento
  #para marcar, durante los cambios, usa \[ \[
  my ($dado,$refcirc,$temp) = @_;
  my $sust; # desde key_iniciales se llama con TEMP
  if (not defined $temp) {
      error_progr($refcirc, 
                  'Term '. __LINE__ .'no se ha indicado temp ni TEMP');
  };
  #impr_debug(__LINE__.' Term $refcirc->{TEMP}', $refcirc->{TEMP});  
  #impr_debug(__LINE__.' Term $refcirc->{temp}', $refcirc->{temp});  
  # para que no haya constantes en pedido de OUTPUTS a Sceptre o para
  # la identificacion de los valores iniciales 
   
  my ($objeto,$nodoobj,$categ,$cual);
  my $cambiado = $dado;
  my $dato  = ';'.$dado.';';
  #impr_debug(__LINE__.' Term $dato', $dato);
  $dato =~ s/(\W)TEMP/$1&TEMP/g;$dato =~ s/(\W)FLUJO/$1&FLUJO/g;
  my ($categ,$cual);
  while (
         $dato =~ s/(\W+)\s*&(TEMP)_(\w+)(\W+)/$1\[$3\[$4/ 
         or $dato =~ s/(\W+)\s*&(TEMP)\s*(\w+)(\W+)/$1\[$3\[$4/ 
	 or $dato =~ s/(\W+)\s*&(FLUJO)_(\w+)(\W+)/$1\[$3\[$4/ 
	 or $dato =~ s/(\W+)\s*&(FLUJO)\s*(\w+)(\W+)/$1\[$3\[$4/ 
        ) {
            ($categ,$cual)=(uc($2),$3); $sust = $categ . '_' . $cual;
            my ($objeto,$nodoobj);
	    my $bien = 1;
	    if (defined $refcirc->{cualobjele}->{$cual}) {
	        $objeto = $refcirc->{cualobjele}->{$cual}->[-1];
            };
	    if (defined $refcirc->{cualobjtextonodo}->{uc($cual)}) {
	        $nodoobj=$refcirc->{cualobjtextonodo}->{uc($cual)}->[-1];   
            };
            if (uc($categ) eq 'FLUJO'){
                if (defined ($objeto)){
                    $cual =~ /^[RCEL]/i and $sust = "I$cual"  
	          or  $cual =~ /^J/i and $sust = $cual
	          or do{
		   $bien = 0;
		  };
	        } else {
		   $bien = 0;
		}
            } elsif (defined ($objeto)) {  #  TEMP
	        $cual =~ /^E/i  and $sust = $cual
		or $cual =~ /^[CRJL]/i  and $sust = "V$cual"
		or do{
		   $bien = 0;
		   }; 
            } elsif (defined $nodoobj) { 
                 if (defined($refcirc->{$temp}->{uc($cual)})) { 
                        $sust = $refcirc->{$temp}->{uc($cual)}
		 } else {
		      $sust=cerofuentear($refcirc,uc($cual));
		 };
            } else {
	         $bien = 0;
	    }; 	  
            unless ($bien) {
                avnoseent($dato);
	    };
            if ($sust =~ /^\-/) {
                $dato =~ s/\[$cual\[/\[$sust\[/;
                $dato =~ s/\-\[\-(.+)\[/+$1/ or  $dato =~ s/\+\[\-(.+)\[/-$1/
		    or $dato =~ s/\[(.*)\[/($1)/;
	    } else {
                $dato =~ s/\[$cual\[/$sust/ ;
            };
    }
  $dato =~ s/^;(.*);$/$1/;
  #impr_debug(__LINE__.' Term nuevovalor',$dato);
  comfin('fin interpretar_var_termica',$dato);
    return ($dato) ;
}# interpretar_var_termica
# ---------------------------------------------------------------------------
sub interpretar_values_termico{ 
  comfin('com interpretar_values_termico',@_);
  my ($lisque,$ref)=@_; 
  for my $que (@$lisque) {
     my $dummy; #unidad
     my $cuantasdefi = 0;;
     foreach my $key (keys %{$ref->{$que}}){#no importa el orden (casi)
	 my ($valor,$tipo,$tiparg,$refarg) = tomar_datos($ref,$que,$key);
#impr_debug(__LINE__.' Term $valor,$tipo,$tiparg,$refarg '
#	   ,[$valor,$tipo,$tiparg,$refarg]);
	 next if $tipo =~ /[npebzIvij;]/;
         my $temp = 'temp';
         if ($tipo eq 'a') {
             my $nuevovalor
                 = interpretar_var_termica($valor,$ref,$temp);
             next if $nuevovalor eq 'NOSEENTIENDE' 
                     or $nuevovalor eq $valor;
             $nuevovalor !~ /^\D/ and $tipo = 'n';   
             cargar_datos($ref, $que, $key, $nuevovalor,$tipo,'',0
                         ,__LINE__.' Term int_val_term');
             next;
         };
         #impr_dat_que($key,$que,__LINE__.' Term ',$ref,'ivt');
         if (not defined $refarg) {
               ($tipo,my $argus,my $nfunc,$tiparg,$valor,$refarg) 
                   = Tablasfuncq::tipear($ref,$valor,1);
               cargar_datos($ref,$que,$key,$valor,$tipo,$tiparg,$refarg
                         ,__LINE__. ' Term ');
         };
         my @listaarg = @$refarg;
         #impr_debug(__LINE__.' Term REFARG',$refarg);
         my $cambio =''; my $tipargv = $tiparg;
         foreach my $argu (@listaarg) {
             $tipargv =~ s/^(.)//;  
             my $tipito = $1; 
             next if $tipito =~ /[np]/;
             my $nuevoargu = interpretar_var_termica($argu,$ref,$temp);
             next if $nuevoargu eq 'NOSEENTIENDE' or $nuevoargu eq $argu;
             $nuevoargu !~ /^\D/ and $tipo = 'n';
             #impr_debug(__LINE__.' Term $que $key $argu $nuevoargu '
             #               ,"$que $key $argu $nuevoargu");
             $cambio = 1; my $cuan = 0;
             while ($valor =~ s/(\W)$argu(\W)/$1$nuevoargu$2/ and $cuan <5){
                  $cuan ++
             };
             $argu = $nuevoargu;
         };
        
        next unless $cambio;
        #impr_debug(__LINE__.' Term $que $key $valor $nuevovalor', 
        #  "$que $key $valor");  
        #impr_debug(__LINE__.' Term $valor REFARG '
        #     , ,$ref->{"REFARG$que"}->{$key}); 
        cargar_datos($ref, $que, $key, $valor,$tipo,$tiparg
                         ,\@listaarg
                         ,__LINE__.' Term int_val_term');
   };#$key
  }; #$que
  comfin('fin interpretar_values_termico',$lisque,$ref,'impr');
} #interpretar_values_termicos     
# ----------------------------------------------------------------------------
sub interpretar_values_iniciales{
  #en relacion con valores iniciales para VC...
  comfin('com interpretar_values_iniciales',@_);
  my $refcirc = $_[0]; 
  #impr_datos(__LINE__.' Term', ['INICIALES'], $refcirc);
  my ($refini, $tiprefini);
  $refini = $refcirc->{INICIALES}; 
  scalar keys %$refini or return 0;
  $tiprefini = $refcirc->{TIPINICIALES} or $tiprefini = {}; 
  my @parsn = grep(lc($refcirc->{TIPPARAMETROS}->{$_}) eq 'n'
		   ,keys %{$refcirc->{PARAMETROS}});
  #impr_debug(__LINE__.' Term @parsn',\@parsn); 
  my %INICIALESORI = %$refini; 
  #impr_debug(__LINE__.' Term @$refini',Dumper $refini); 
  my @nonum = grep(do{$tiprefini->{$_} !~ /[\;n]/}
           , keys %$tiprefini); 
  #impr_debug(__LINE__.' Term @nonum',\@nonum); 
  #map (impr_dat($_,__LINE__.' Term',$refcirc,'ik'),@nonum);
  for my $key (@nonum) {
      my $valor = $refini->{$key};
      #print 'Term ' . __LINE__ . " $valor\n";
      if ($valor =~ /^QPRODUCTO.*\W0\W/ ) { 
          cargar_datos($refcirc, 'INICIALES', $key, '0.', 'n', '',0
                       ,__LINE__.' Term' ,__LINE__.' Term int.keys_ini');
      } else {avgrav("El valor inicial para $key, $refini->{$key},
            no es una constante"); $refini->{$key} .= '; no es constante';
          cargar_datos($refcirc, 'INICIALES', $key,
	              $valor . 'no es una constante', 'e', '',0
                       ,__LINE__.' Term int.keys_ini');
          next;   
      };
  };   
  my (%hashesiniciales); 
  my $listaIN;
  @$listaIN = @{$refcirc->{listaINICIALES}}; 
  #impr_debug(__LINE__.' Term', Dumper $refcirc->{INICIALES});
  #impr_debug(__LINE__.' Term', $listaIN);
  foreach my $cosa ( keys %{$refcirc->{INICIALES}} ) {
      next unless $cosa =~ /^V/;
      my $dosnodos = $refcirc->{uni}->{substr($cosa,1)}; 
      $hashesiniciales{$dosnodos}->{$refcirc->{INICIALES}->{$cosa}}++ ;
  };
  my $rerunini = $refcirc->{rerun}->{INICIALES}; 
  #impr_debug(__LINE__.' Term $rerunini',$rerunini)
  #    if defined $rerunini;
  my $refcualesC = {};
  foreach my $nodo  (keys %{$refcirc->{cualesEC}}) {
      my @prolista =  @{$refcirc->{cualesEC}->{$nodo}};
      @prolista = grep(/^C/,@prolista);
      $refcualesC->{$nodo} = [@prolista];
  };

  foreach my $nodo (keys %{$refcualesC}) {
      my @prolista =  @{$refcualesC->{$nodo}};
      my @listaCno = grep (do{/^C/
                             and not defined $refcirc->{INICIALES}->{"V$_"}}
                         , @prolista);
      next unless @listaCno;
      my @listaCsi = grep (do{/^C/ 
                             and defined $refcirc->{INICIALES}->{"V$_"}}
                         , @prolista);
      my $valor = $refcirc->{INICIALES}->{"V$listaCsi[0]"};
      foreach my $iden (@listaCno) {
          cargar_datos($refcirc,'INICIALES',"V$iden", $valor, 'n','',0
                     ,__LINE__.' Term int.keys_ini');
          push @{$refcirc->{listaINICIALES}}, "V$iden";
      };
      foreach my $iden (@listaCsi) {
          $hashesiniciales{$nodo}->{$refcirc->{INICIALES}->{"V$iden"}}++;
      };
  };
  my @listakeys = keys %$refini;
  #impr_debug(__LINE__.' Term @listakeys',Dumper $refini);
  for(my $i = 0; $i < @listakeys; $i++) {
      my $key = $listakeys[$i];
      next if $tiprefini->{$key} =~ /^;/; 
      if ($key =~  /^V([RLCJ].+)/ or $key =~ /^I([RLCE].+)/) {
          defined $refcirc->{cualobjele}->{$1}
	  or do{avgrav("$key ha recibido valor inicial, pero $1 no existe");
              $refini->{$key}.= "; $1 no existe"; next
          };
      } elsif ($key =~ /^P/) {
          defined $refcirc->{PARAMETROS}->{"D$key"} 
	  or do{avgrav("$key no es un parámetro a integrar; no aparece D$key;
	      no necesita valor inicial"); 
              $refini->{$key} .= "; $key no es un integrable"; 
              next;
	  };   
      } elsif ($key =~ /^V(E.*)/ or $key =~ /^I(J.*)/ 
               or  $key =~ /^(E.*)/ or $key =~ /^(J.+)/) {
          avgrav("La fuente $1 no necesita un valor inicial; es el mismo para
             " . join '  ',$refcirc->{INIorig}->{$key}); 
          $refini->{$key} .= '; no tiene sentido'; 
          next;
      } else {
          avgrav("No se entiende dar valor inicial para $key");
          $refini->{$key} .= '; no se entiende'; next;
      }; 
  };
  my @nodosparainiciales = grep( scalar @{$refcualesC->{$_}}, 
                                   keys %{$refcualesC});
  my @nodossinvalor =  grep(do{scalar keys %{$hashesiniciales{$_}} == 0},
                            @nodosparainiciales);
  my @repes = grep(do{scalar keys %{$hashesiniciales{$_}} > 1},
                   @nodosparainiciales);
  @repes and do{
      avgrav("Hay valores iniciales distintos que debieran ser iguales");
     map (mensaje("      V" . join (' V',@{$refcualesC->{$_}}) 
	          .': ' . join (' ',keys %{$hashesiniciales{$_}})),
          @repes);
  };
   #impr_debug(__LINE__.' Term @nodossinvalor', "@nodossinvalor");   
  @nodossinvalor and do{
      my @acussininicial;
     map (push(@acussininicial, @{$refcualesC->{$_}}),@nodossinvalor);
      avgrav("Faltan valores iniciales para nodo(s): "
           . join (' ', @nodossinvalor));   
     map (do{$refini->{"V$_"} = 'no definido';
	    mensaje(descripcion_nombre($_,$refcirc->{cualobjele}) 
		  . ":  V$_"),"\n"
	         },
          @acussininicial);		 
  };
  if ($avisosgrav) {
      my $texto = imprhash('',%INICIALESORI,13); # 13 espacios; y no escribe
      mensaje
      ("Errores, incompatibilidades o faltantes en los valores iniciales\n" .
           $texto);
  };
  return 0;    
  comfin('fin interpretar_values_iniciales',['INICIALES'],$refcirc,'impr');
}#interpretar_values_iniciales     
#----------------------------------------------------------------------------
sub tipear_cosa{
  # devuelve  lista con las características del pedido; 
  # $tipo, $plantilla,$eleparnodo,$i
  #con tipo E si hay anbiguedad
  #lista vacia si no encontro acuerdo 
  # 
  # y plantilla (0 cuando no corresponde)
  #comfin('com tipear_cosa',@_);
  my ($ref,@listacont0) = @_; my @lista;
  #impr_debug(__LINE__.' Term @listacont0', Dumper \@listacont0);
  for(my $i = 0; $i < @listacont0; $i ++) {
      my $cont0  = $listacont0[$i];
      my $eleparnodo = uc($cont0); my ($tipo,$plantilla);
      $eleparnodo =~ s/^_//;
      #impr_debug(__LINE__.' Term  $eleparnodo', "'$eleparnodo'");
      #impr_debug(__LINE__.' Term NODOSPLANT', Dumper $ref->{NODOSPLANT});
      #impr_debug(__LINE__.' Term ELESPLANT', Dumper $ref->{ELESPLANT});   
      if (defined  $ref->{ELESPLANT}->{$eleparnodo} 
                 and $ref->{ELESPLANT}->{$eleparnodo}
            and $eleparnodo !~ /^T/) { #no corresponden modelos
          $tipo = 'a'; $plantilla = $ref->{ELESPLANT}->{$eleparnodo};
	  #impr_debug(__LINE__.' Term  $eleparnodo $plantilla'
          #           ,[$eleparnodo, $plantilla]);  
      } elsif ($eleparnodo eq 0) { #nodo tierra
          $tipo = 'n'; $plantilla = 0;
      } elsif (defined $ref->{NODOSPLANT}->{$eleparnodo}) {
          $tipo = 'n'; $plantilla =  $ref->{NODOSPLANT}->{$eleparnodo};
      } elsif (defined $ref->{PARAMETROS}->{$eleparnodo} or
                 defined $ref->{PARAMETROS}->{"D$eleparnodo"}) {
          $tipo = 'p'; $plantilla = 0; 
      } elsif ($eleparnodo eq 'TIME' or $eleparnodo eq 'TIEMPO') {
          $tipo = 't'; $plantilla = 0;
      } else {
          $tipo = 'e'; $plantilla = 0;
      };
      push @lista, [$tipo,$plantilla, $eleparnodo,$i];
  }; #foreach
  @lista = grep($_->[0] ne 'e',@lista);
  #comfin('fin tipear_cosa', @lista);
  #impr_debug(__LINE__.' Term @lista', Dumper \@lista);
  #Luego, solo se perdonará 'equivocarse' de abreviatura si no resultan ambig. 
  return \@lista;
} #tipear_cosa
# ----------------------------------------------------------------------------
sub registrar_equivalencias{
    comfin('com registrar_equivalencias', @_);
    my ($ref) = $_[0];
    #impr_debug(__LINE__.' Term $defiabrev', Dumper $defiabrev);
    #impr_debug(__LINE__.' Term $defiequiv', Dumper $defiequiv);
    my ($hashpalabras, $equivpalabra, $plantipalabra) = ({},{},{});
    foreach my $plantilla (5 .. @$nombreplantilla -1) {
        my $nomplantilla = $nombreplantilla->[$plantilla];
    #impr_debug(__LINE__.' Term $defiabrev $plantilla'
    #          , Dumper $defiabrev->{$plantilla});
    #impr_debug(__LINE__.' Term $defiequiv $nomplantilla'
    #          , Dumper $defiequiv->{$nomplantilla});
        $plantipalabra->{V}->{$plantilla} = 1;
        $plantipalabra->{I}->{$plantilla} = 1;
        $plantipalabra->{''}->{$plantilla} = 1;
 	$hashpalabras->{V} = $hashpalabras->{I} = $hashpalabras->{''} = 1;
        $equivpalabra->{V}='V'; $equivpalabra->{I}='I';$equivpalabra->{''} ='';
        foreach my $key (keys %{$defiabrev->{$plantilla}}) {
            my $abr = $defiabrev->{$plantilla}->{$key};
	    $hashpalabras->{$abr} = 1;
            my $nuevo = $defiequiv->{$nomplantilla}->{$abr};
            my $viejo = $equivpalabra->{$abr};
            if (defined $viejo and $viejo ne $nuevo) {
                  parar1(66,0,"Ambigüedad proveniente de cuadros UNIDADES
                      equivalencias para $abr: $viejo $nuevo");
            };
            $equivpalabra->{$abr} = $nuevo;
            $plantipalabra->{$abr}->{$plantilla} = 1; 
        };
    };
    %{$ref->{hashpalabras}} = %{$hashpalabras}; 
    %{$ref->{equivpalabra}} = %{$equivpalabra};
    %{$ref->{plantipalabra}} = %{$plantipalabra};
    comfin('fin registrar_equivalencias', $ref, keys %$equivpalabra);
    return '';
} #registrar_equivalencias
# ----------------------------------------------------------------------------
sub buscar_abreviaturas{
 # comfin('com buscar_abreviaturas',@_);
  my ($refcirc, $pal1, $cont00,$quien) = (@_,''); 
  #$cont00 es contenido del primer parentesis; si no se usa,
  #se devuelve tal cual si no se usa;
  #si se usa se devuelve ''
  my (@listacont0,$refcuaternas,$refpar);
  #impr_debug(__LINE__.' Term $DEFIUNI',Dumper $DEFIUNI);
  my ($hashpalabras,$equivpalabra,$plantipalabra) =
       ($refcirc->{hashpalabras},$refcirc->{equivpalabra}
        ,$refcirc->{plantipalabra});  
  $hashpalabras->{''} = 1; $equivpalabra->{''} = ''; 
  #si no se ejecuto registrar_equivalencias ..., se necesita lo anterior
  $refpar = [];
  #buscamos dif. de tension entre dos nodos o ....:
  $cont00 =~ s/^\s*//; $cont00 =~ s/\s*$//;
  my @liscont00 = split /\s*\-\s*/,uc($cont00); my $nombre;
  #impr_debug(__LINE__.' Term @liscont00 ', \@liscont00);
  #impr_debug(__LINE__.' Term $equivpalabra ', $equivpalabra);
  #impr_debug(__LINE__.' Term $hashpalabras ', $hashpalabras);
  #impr_debug(__LINE__.' Term $defiabrev ', Dumper $defiabrev);

  my ($tipo,$plantilla,$eleparnodo,$cont0,$palequiv,$pala,$propio);
  if ($quien ne 'INICIALES' and  defined $hashpalabras->{$pal1}
          and @liscont00 == 2 and $equivpalabra->{$pal1} eq 'V'
          and defined $refcirc->{cualobjtextonodo}->{$liscont00[0]}
          and defined $refcirc->{cualobjtextonodo}->{$liscont00[1]}) {
      $nombre =  $refcirc->{TEMP}->{"$liscont00[0]-$liscont00[1]"};
      defined $nombre or        
          $nombre = cerofuentear($refcirc,$liscont00[0],$liscont00[1]);
      $propio = "$pal1($cont00)";
      $cont00='';
      $tipo = 'a'; 
      $nombre =~ /^E/ and $eleparnodo = $nombre 
          or $eleparnodo = substr($nombre,1); 
      $cont0 = $eleparnodo;
      my $obj = $refcirc->{cualobjtextonodo}->{$liscont00[0]}->[0];
      $plantilla = $plantillalista->[$obj]; 
      #impr_debug(__LINE__.' Term $plantilla',$plantilla);
      $palequiv = 'V'; $pala = $pal1;  
  } else {  
      foreach my $palabra (keys %$hashpalabras) {
          $palequiv = $equivpalabra->{$palabra};
          if ($pal1 =~ /^$palabra(.*)$/i) {
              my $cont0 = $1; $cont0 =~ s/^\s*//; $cont0 =~ s/\s*$//;
              # next if (($cont0  ne '' and $cont00 ne '')
              #          or ($cont0 eq '' and $cont00 eq '')); 
              my $propio;
              if ($cont0 eq '') {
	          $cont0 = $cont00; $cont00 = '';
                  ($cont00 eq '' and $propio = $pal1) 
                              or $propio = "$pal1($cont00)"; 
              } else {
                  $propio = $pal1; 
              }; 
              push @$refpar, [$palabra, $cont0];    
              push @$refcuaternas, [$palequiv,$palabra,$propio,$cont00];
              push @listacont0, uc($cont0);
          };
      };
      #impr_debug(__LINE__.' Term @listacont0', Dumper \@listacont0);
      #impr_debug(__LINE__.' Term $refcuaternas', Dumper $refcuaternas);
      #impr_debug(__LINE__.' Term $refpar', Dumper $refpar);
      my $reflista = tipear_cosa($refcirc,@listacont0);
      #impr_debug(__LINE__.' Term $reflista', Dumper $reflista); 
      if (@$reflista == 0) {
          $reflista =[['e',0,'??','']];      
      } elsif (@$reflista == 1) {
          my ($tipo,$plantilla,$eleparnodo, $i) = @{$reflista->[0]};
          my $abr = ''; 
          if ($tipo eq 'n') {
              $abr = $defiabrev->{$plantilla}->{E};
          }; 
          not $abr or ($abr and $abr eq $refpar->[$i]->[0]) or 
          do{ avnograv("Sería mejor hacer el pedido de resultado 
                $pal1    como    $abr $eleparnodo"); 
          };  
          #$plantipalabra->{$refpar->[0]->[0]}->{$plantilla} or
      } elsif (@$reflista >1) {
          my @reducida;
          foreach my $reflistita (@$reflista) {
              ($plantilla,my $i) = ($reflistita->[1],$reflistita->[3]);
              if ($plantipalabra->{$refpar->[$i]->[0]}->{$plantilla}) {
                  push @reducida, $reflistita;
              }; 
          };  
          @reducida == 1 and $reflista = \@reducida
              or  do{
              foreach my $par (@$refpar) {
                  push @{$refcirc->{confuso}},"$par->[0] $par->[1]";
              };
              parar1(75,$refcirc,"Hay ambigüedad en $quien:
               $pal1$cont00; separe con espacios o utilice paréntesis
               @{$refcirc->{confuso}}");
	  };   
      };
      ($tipo,$plantilla,$eleparnodo,my $i) = @{$reflista->[0]};
     #impr_debug(__LINE__.' Term $plantilla',$plantilla);
      if ($tipo eq 'e') {
          $eleparnodo = '??'; $cont00 = '??,??,??'; $cont0 ='';
          ($palequiv, $pala,$propio) = ('??','??','??');
      } else {
          $cont0 = $listacont0[$i]; my $refcua = $refcuaternas->[$i] ;
          ($palequiv, $pala,  $propio, $cont00) = @$refcua; 
      };
      if ($tipo eq 'a' and $pala eq '') {
          $eleparnodo =~ /^J/  and $palequiv = 'I'
            or 
          $eleparnodo =~ /^E/  and $palequiv = 'V';
      };
  }; #if else 
 # comfin( 'fin buscar_abreviaturas',':::',
 #    , ($tipo,$plantilla,$eleparnodo,$cont0,$palequiv,$pala,$propio,$cont00)); 
  return ($tipo,$plantilla,$eleparnodo,$cont0,$palequiv,$pala,$propio,$cont00);
} 
# ----------------------------------------------------------------------------
sub normalizar_abreviaturas{
  #normaliza abreviaturas relacionadas con TEMP, FLUJO ...
  comfin('com normalizar_abreviaturas', @_);
  my ($listaque, $ref) = @_;
  my ($hashpalabras,$equivpalabra) = 
      ($ref->{'hashpalabras'},$ref->{'equivpalabra'});
  my @lista = keys %{$ref->{equivpalabra}};
  #impr_debug(__LINE__.' Term equivalencias',\@lista);
  #Hay que detectar primero los pedidos equivalentes a V(xx-yy)
  foreach my $que (@$listaque) {
      my $refque = $ref->{$que};
      my $VAR1;
      my $total = Dumper $refque;
      #impr_debug(__LINE__.' Term $total '. $que,$total);
      foreach my $pal1 (keys %$hashpalabras) {
          next if $pal1 eq ''; #de otro modo puede haber loop infinito
          while 
           ($total=~ s/(\W)$pal1\((\w+\-\w+)\)(\W)/$1$pal1&\($2\)$3/) {
              my @octeto = buscar_abreviaturas($ref,$pal1,$2,'normal');
              $octeto[0] ne 'a' and next;
              my ($tipo, $plantilla, $cosa, $cont0, $palequiv,$pala
                         ,$propio, $cont00)  = @octeto;
              my $sust = "V$cosa"; $sust =~ s/^VE/E/;
              $total =~ s/(\W)$pal1&\((\w+\-\w+)\)(\W)/$1$sust$3/;
	  };
          $total =~ s/&//g;         
      };
      #impr_debug(__LINE__.' Term $total '. $que,$total);
      $refque = eval($total);
      #impr_datos(__LINE__.' Term', [$que], $ref);
      foreach my $key (keys %{$ref->{$que}}) {
          next if lc($ref->{"TIP$que"}->{$key}) =~ /[;pne]/;
          #impr_dat_que($key,$que,__LINE__.' Term normalizar_ab',$ref,'na');
          #las expresiones son las partes de lista 
          #que aparecen en DATOS; o  valores para PARAMETROS, INICIALES ...
          #la expresion comenzara y terminara con ';'; 
          #solos o junto a otro separadores
          my $expresionori = $refque->{$key};
          if ($que eq 'temp') {
             if ($expresionori =~ /^TEMP/) {
                 my $valor = $ref->{TEMP}->{$key}; 
                 my $tipoval = $ref->{TIPTEMP}->{$key};
                 while (defined $ref->{TEMP}->{$valor}
                        and $valor ne $ref->{TEMP}->{$valor}) {
                     $tipoval =  $ref->{TIPTEMP}->{$valor};
                     $valor = $ref->{TEMP}->{$valor}; 
                     #impr_debug(__LINE__.' Term ',[$key,$valor,$tipoval]); 
                 };
                 $ref->{temp}->{$key} = $valor;
                 $ref->{TIPtemp}->{$key} = $tipoval; 
                 #impr_dat_que($key,'temp',__LINE__.' Termq normalizar_ab'
                 #            ,$ref,'nac');  
	      };
	     next;
	  };
          my $tipo = $ref->{"TIP$que"}->{$key};
          my $xfun; $tipo eq 'x' and do{
             $expresionori =~ s/^(X\w+)\((.+)\)$/$2/;
             $xfun = $1;               
          }; 
          my $expresion = ';' . $expresionori .';';      
          my @listamezcla = $expresion =~ /([\w\.]+)/g; #lista de palabras 
          my @listasepa = split /[\w\.]+/, $expresion; #lista de separadores
          if (@listamezcla + 1 != @listasepa)  {
              error_progr($ref,"No se esperaba una expresión así
                $expresion 
              ". __LINE__.' Alg'); 
	  }; 
	  my $expresionnueva = $listasepa[0]; my $cambio ='';
          for(my $i = 0; $i < @listamezcla; $i++) {
              my $pal1 = uc($listamezcla[$i]); my $sepa = $listasepa[$i+1];
              my $sepamenos = $listasepa[$i];
              my $deltai= 0; my $sepa1;
              if ($pal1 !~ /^\w/ or $pal1 =~ /^\d/) {
              } else {
                  my $cont = ''; 
                  my $pal2 = uc($listamezcla[$i+1]); 
                  $sepa1 = $listasepa[$i+2];
                  if(defined $pal2 
	              and $sepa =~ /^\s*\(\s*$/ and $sepa1 =~ s/^\s*\)//)  {
	              $cont = $pal2; $deltai = 1;
                  } else { 
                      $pal2 = ''
                  };
                  my @octeto = buscar_abreviaturas($ref,$pal1,$pal2,'normal');
                      #norm._abrev
                  if (@octeto == 0 or $octeto[0] eq 'e') {
                      $deltai = 0;
                  } else {
                      $cambio = 1;  
                      my ($tipo, $plantilla, $cosa, $cont0, $palequiv,$pala
                         ,$propio, $cont00)  = @octeto;
                         if ($tipo eq 'a') {
                           if ($cosa =~ /^E/ and $palequiv eq 'V' 
                                or $cosa =~ /^J/ and $palequiv eq 'I') { 
	        		   $pal1 = $cosa;
                           } else { 
                               $palequiv =~ /[VI]/   
                                    and $pal1 = "$palequiv$cosa";
                          };
                      } elsif ($palequiv eq 'V' and $tipo eq 'n') {# 'n',  nodo
                               # n por nodo
                          my  $ped = $ref->{temp}->{$cosa};
                          my $tipped = $ref->{TIPtemp}->{$cosa};
                          #if ($tipped !~ /[anp]/ and $sepamenos =~ /\($/) {
                          #    $ped = $ref->{TEMP}->{$cosa};
                          #    $tipped = $ref->{TIPTEMP}->{$cosa};
                          #};
			  #impr_debug(__LINE__
                          #    . ' Term $key $ped $sepamenos $sepa $sepa1'
                          #    , [$key,$ped,$sepamenos,$sepa,$sepa1]);
                          if (defined $tipped and $tipped eq 'n' 
                                   #n  por numerico
                                and $ped < 0) {
                              $expresionnueva =~ s/(.)$//; my $pre = $1;
                           ($pre, $ped) 
                                = Algebraico::simpl_expre_negnum($pre,$ped);
                             $expresionnueva .= "$pre"; 
                          };                     
                          defined $ped or $ped = $ref->{TEMP}->{$cosa};
                          if (defined $ped) {
                              $pal1 = $ped 
		          } else {
	                      $pal1 = cerofuentear($ref, $cosa);
		          };
                     }; 
                  };
                  if ($pal1 =~ /^[EJ]/ and defined $ref->{DATOS}->{$pal1}){
		      my $tipopal1 = $ref->{TIPDATOS}->{$pal1};
                      my $valorpal1 = $ref->{DATOS}->{$pal1};
                      if ($tipopal1 eq 'n' and $valorpal1 < 0) {
			   $pal1 = $valorpal1;
                           $expresionnueva =~ s/(.)$//; my $pre = $1;
                           ($pre, $pal1) 
                              = Algebraico::simpl_expre_negnum($pre,$pal1);
                           $expresionnueva .= "$pre";        
		      };
                  }
              }; # if  $pal1 else
              if ($deltai) {
                  $expresionnueva .= "$pal1$sepa1";
                  $i ++;
              } else {
                  $expresionnueva .= "$pal1$sepa";
              };  
         }; #for $i
         next unless $cambio;
	 $expresionnueva eq ";$expresionori;" and next;
	 impr_debug(__LINE__.' Term $cambio,$expresionnueva'
                  ,[$cambio,$expresionnueva]);
         $expresionnueva =~ s/^\;(.+)\;$/$1/;
         my ($tipon, $argus, $func, $listatiparg, $nvalor, $reflistaargus) 
             = Tablasfuncq::tipear($ref,$expresionnueva,1);
	 $tipon eq 'x' and defined $xfun and $xfun ne $func and do{
             $nvalor =~ s/^$func\(/$xfun\(/;
         };    
         cargar_datos($ref,$que,$key,$nvalor,$tipon,$listatiparg
                        , $reflistaargus, __LINE__.' Term normalizar_ab'); 
     }; #for $key
  }; #for $que
  my $lisque; @$lisque = (@$listaque,'TEMP');  
  comfin('fin normalizar_abreviaturas',$lisque,$ref,'impr' );
  return '';
} 
# ---------------------------------------------------------------------------
sub temperaturas{ #elementos con una sola conexion tienen temperatura de ella
  # y parecido para conexiones 0-? o ?-0
  #se tiene temp en los nodos y temp de esos elementos con un solo nodo
  #ya se habrá controlado que no hay fuentes de tension en paralelo
    comfin('com temperaturas',@_);
    my $refcirc = $_[0];
    my $uni = $refcirc->{uni};
    (defined $uni and scalar keys %$uni) or do{
        mensaje('No hay nodos utilizados');
	return '';
	};
    cargar_datos($refcirc, 'temp', '0', '0','n','',0
                        ,__LINE__.' Term temp.');
    my $newpar = Algebraico::crear_parametro($refcirc, 'Z', 0);
    cargar_datos($refcirc,'TEMP','0',$newpar,'p','',0
                        ,__LINE__.' Term temp.');
    my @listadedos = grep(do{($uni->{$_} =~ tr/-//) == 1},
                     keys  %{$refcirc->{cualobjele}});
    my @listadesde0E = grep(do{$uni->{$_} =~ /^0\-\w+$/ and /^E/}
          ,@listadedos);
    my @listanoE = sort grep(do{$uni->{$_} =~ /^\w+\-0$/ 
                         and $_ !~ /^E/},@listadedos);
    my @listanodesde0E = grep(do{$uni->{$_} !~ /^0\-\w+$/ and /^E/}
         , @listadedos); 
    # en ...   ->{temp}->{"$iden"}, el "mejor para cálculo"
    # , si es posible numerico
    # en ...   ->{TEMP}->{"$iden"}, nunca el numerico; 
    # el más significativo 
    #        (en {TEMP} apto para ser pedido como resultado 
    # en ...   ->{TEMP}->{$nodo}, nunca el numerico; el más significativo 
    # en ...   ->{temp}->{$nodo}, el "mejor para cálculo", 
    # si es posible numerico
    # el no aceptar tensiones de elementos cuyos valores son complicados 
    # es para evitar los delays de calculo anunciados
    #impr_debug(__LINE__.' Term temp. @listadesde0E',\@listadesde0E);
    foreach my $iden (@listadesde0E) {
      (my $nodo = my $dosnodos = $uni->{$iden}) =~ s/^0\-(\w+)$/$1/;
      cargar_datos($refcirc,'TEMP',$iden, $iden, 'a','',0
                         ,__LINE__.' Term temp.');  
      (my $nodosdos = $dosnodos) =~ s/^(.+)\-(.+)$/$2\-$1/; 
      copiar_datos($refcirc,'TEMP',$iden,$refcirc,'TEMP',$nodosdos
                         ,__LINE__.' Term temp.');  
      copiar_datos($refcirc,'TEMP',$iden,$refcirc,'TEMP',$nodo
                         ,__LINE__.' Term temp.');  
      push @{$refcirc->{cualesEC}->{$nodosdos}}, "$iden";   
      #next unless $refcirc->{TIPDATOS}->{$iden} =~ /([npta])/;
      ## si no es mejor una J nula
      #copiar_datos($refcirc, 'DATOS',"$iden",$refcirc,'temp',$iden
      #                  ,__LINE__.' Term temp.');  
      #copiar_datos($refcirc, 'DATOS', $iden, $refcirc,'temp',$nodo
      #                 ,__LINE__.' Term temp.'); 
      #copiar_datos($refcirc, 'DATOS', $iden, $refcirc,'temp'
      #             ,$nodosdos #no usa
 #		   ,__LINE__.' Term temp.'); 
    };
    #impr_debug(__LINE__.' Term temp. @listanodesde0E',\@listadesde0E);
    foreach my $iden (@listanodesde0E) {
      my $dosnodos = $uni->{$iden}; 
      cargar_datos($refcirc,'TEMP',$iden, $iden, 'a','',0
                         ,__LINE__.' Term temp.');  
      (my $nodosdos = $dosnodos) =~ s/^(\w+)\-(\w+)$/$2\-$1/; 
      copiar_datos($refcirc,'TEMP',$iden,$refcirc,'TEMP',$nodosdos
                         ,__LINE__.' Term temp.');  
      push @{$refcirc->{cualesEC}->{$nodosdos}}, "$iden";   
    };
   #impr_debug(__LINE__.' Term temp. @listanoE',\@listanoE);   
    foreach my $iden (sort @listanoE) {
      my $dosnodos = $uni->{$iden}; 
      my $nodo = $dosnodos; $nodo =~ s/^(\w+)\-0$/$1/;
      if  (not defined $refcirc->{TEMP}->{$dosnodos}) {
         cargar_datos($refcirc,'TEMP',$dosnodos, "V$iden",'a','',0
                   ,__LINE__.' Term temp.');
      };
      copiar_datos($refcirc,'TEMP',$dosnodos,$refcirc,'TEMP',$iden
		   ,__LINE__.' Term temp.');
      copiar_datos($refcirc,'TEMP',$dosnodos, $refcirc,'TEMP',$nodo
                   ,__LINE__.' Term temp.')
	     if $nodo ne $dosnodos;      
      push @{$refcirc->{cualesEC}->{$dosnodos}}, $iden
          if $iden =~ /^C/;
    }; 
    #impr_debug(__LINE__.' Term temp. cualesEC'
    #                 ,Dumper $refcirc->{cualesEC});   
    foreach my $cosa (keys %{$refcirc->{TEMP}}) {
        my $valor = $refcirc->{TEMP}->{$cosa};
        my $que = 'TEMP';
        if ($valor =~ /^[EJCRL]/) {
            my $tiponvalor = $refcirc->{TIPDATOS}->{$valor};
            $tiponvalor =~ /[na]/ and $que = 'DATOS';
        } elsif ($valor =~ /^P/) {
            my $tiponvalor = $refcirc->{TIPPARAMETROS}->{$valor};
            $tiponvalor =~ /[nap]/ and $que = 'PARAMETROS';
        } else {
            $valor = $cosa;
        };
        copiar_datos($refcirc,$que,$valor, $refcirc,'temp',$cosa
                      ,__LINE__.' Term temp.');    
    };
    foreach my $dosnodos (keys %{$refcirc->{cualesEC}}) {
      #(my $nodosdos = $dosnodos) =~ s/(.+)\-(.+)/$2\-$1/;
      my @lista = @{$refcirc->{cualesEC}->{$dosnodos}};
      my @listab = ();
      #if (defined $refcirc->{cualesEC}->{$nodosdos}) {
      #   @listab =@{$refcirc->{cualesEC}->{$nodosdos}};
      #};
      if (@lista > 1 and $lista[0] =~ /^E/) {
          avgrav(
        "No es aceptable para Sceptre, $lista[0] en paralelo con $lista[1]");
          last;
      #} elsif (@lista > 0 and @listab >0 
      #    and (@lista[0] =~ /^E/ or @listab[0] =~ /^E/)) {
      #    avgrav("Sceptre no acepta, $lista[0] en paralelo con $listab[0]");
      #    last;
      };
    }; 
    comfin('fin temperaturas ',  'cualesEC'
                ,['TEMP','temp'],$refcirc,'impr');
    parar1(220,$refcirc) if $avisosgrav;
    return '';   
} #temperaturas
1
 
